#ifndef _KABI_LRU_GEN_H
#define _KABI_LRU_GEN_H

#ifdef CONFIG_LRU_GEN
#include <linux/xarray.h>
#include <linux/mmzone.h>
#include <linux/mm_types.h>

extern struct xarray kabi_lru_gen;

struct kabi_task_struct {
       unsigned in_lru_fault:1;
};

struct kabi_mm_struct {
	struct lru_gen lru_gen;
};

struct kabi_mem_cgroup {
       struct lru_gen_mm_list mm_list;
};

struct kabi_lruvec {
       /* evictable pages divided into generations */
       struct lru_gen_struct           lrugen;
       /* to concurrently iterate lru_gen_mm_list */
       struct lru_gen_mm_state         mm_state;
};

struct kabi_pg_data {
	pg_data_t pg_data;
	/* kswap mm walk data */
	struct lru_gen_mm_walk	mm_walk;

	// for __lruvec
	/* evictable pages divided into generations */
	struct lru_gen_struct		lrugen;
	/* to concurrently iterate lru_gen_mm_list */
	struct lru_gen_mm_state		mm_state;
};

struct kabi_reclaim_state {
	unsigned long reclaimed_slab;
	/* per-thread mm walk data */
	struct lru_gen_mm_walk *mm_walk;
};
#endif

#endif
